package generated.terminal.copycardMoneySecure.terminal;

public class AuthData implements HashData, Codeable {

	private int instruction;

	private Secret passphrase;

	private Nonce challenge;

	private int amount;

	public AuthData() {
		instruction = 0;
		passphrase = new Secret();
		challenge = new Nonce();
		amount = 0;

	}

	public AuthData(int instruction, Secret passphrase, Nonce challenge,
			int amount) {
		this.instruction = instruction;
		this.passphrase = passphrase;
		this.challenge = challenge;
		this.amount = amount;

	}

	public int getInstruction() {
		return instruction;
	}
	public Secret getPassphrase() {
		return passphrase;
	}
	public Nonce getChallenge() {
		return challenge;
	}
	public int getAmount() {
		return amount;
	}
	public void setInstruction(int instruction) {
		this.instruction = instruction;
	}
	public void setPassphrase(Secret passphrase) {
		this.passphrase = passphrase;

	}
	public void setChallenge(Nonce challenge) {
		this.challenge = challenge;

	}
	public void setAmount(int amount) {
		this.amount = amount;
	}

	public byte getCode() {
		return Code.AUTHDATA;
	}

	public boolean equals(Codeable other) {
		if (getCode() != other.getCode())
			return false;
		if (this.instruction != ((AuthData) other).instruction)
			return false;
		if (!this.passphrase.equals(((AuthData) other).passphrase))
			return false;
		if (!this.challenge.equals(((AuthData) other).challenge))
			return false;
		if (this.amount != ((AuthData) other).amount)
			return false;
		return true;
	}

	public void copy(AuthData from) {
		this.instruction = from.instruction;
		this.passphrase.copy(from.passphrase);
		this.challenge.copy(from.challenge);
		this.amount = from.amount;
	}

	public AuthData copy() {
		AuthData object = new AuthData();
		object.copy(this);
		return object;
	}

}
