package generated.terminal.copycardMoneySecure.terminal;

import javax.xml.bind.annotation.XmlRootElement;
@XmlRootElement
public class Pay extends Message implements Codeable {

	private int amount;

	private Nonce terminalchallenge;

	public Pay() {
		amount = 0;
		terminalchallenge = new Nonce();

	}

	public Pay(int amount, Nonce terminalchallenge) {
		this.amount = amount;
		this.terminalchallenge = terminalchallenge;

	}

	public int getAmount() {
		return amount;
	}
	public Nonce getTerminalchallenge() {
		return terminalchallenge;
	}
	public void setAmount(int amount) {
		this.amount = amount;
	}
	public void setTerminalchallenge(Nonce terminalchallenge) {
		this.terminalchallenge = terminalchallenge;

	}

	public byte getCode() {
		return Code.PAY;
	}

	public boolean equals(Codeable other) {
		if (getCode() != other.getCode())
			return false;
		if (this.amount != ((Pay) other).amount)
			return false;
		if (!this.terminalchallenge.equals(((Pay) other).terminalchallenge))
			return false;
		return true;
	}

	public void copy(Pay from) {
		this.amount = from.amount;
		this.terminalchallenge.copy(from.terminalchallenge);
	}

	public Pay copy() {
		Pay object = new Pay();
		object.copy(this);
		return object;
	}

}
